/*
 *   This file is a part of the SteamWar software.
 *
 *   Copyright (C) 2025 SteamWar.de-Serverteam
 *
 *   This program is free software: you can redistribute it and/or modify
 *   it under the terms of the GNU Affero General Public License as published by
 *   the Free Software Foundation, either version 3 of the License, or
 *   (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 *   GNU Affero General Public License for more details.
 *
 *   You should have received a copy of the GNU Affero General Public License
 *   along with this program.  If not, see <https://www.gnu.org/licenses/>.
 */

package de.steamwar;

import java.util.*;
import java.util.function.Function;

public class RandomGenerator {

    private static final Random random = new Random();
    private static final Map<Class<?>, Function<Class<?>, ?>> generators = new HashMap<>();

    static {
        generators.put(Integer.class, (clazz) -> random.nextInt());
        generators.put(int.class, (clazz) -> random.nextInt());
        generators.put(Double.class, (clazz) -> random.nextDouble());
        generators.put(double.class, (clazz) -> random.nextInt());
        generators.put(Boolean.class, (clazz) -> random.nextBoolean());
        generators.put(boolean.class, (clazz) -> random.nextBoolean());
        generators.put(Byte.class, (clazz) -> (byte) random.nextInt(127));
        generators.put(byte.class, (clazz) -> (byte) random.nextInt(127));

        generators.put(List.class, aClass -> {
            int length = random.nextInt(10);
            List<Object> list = new ArrayList<>();
            for (int i = 0; i < length; i++) {
                list.add(generators.get(Integer.class).apply(Integer.class));
            }

            return list;
        });

        generators.put(String.class, aClass -> {
            int length = random.nextInt(10);
            StringBuilder builder = new StringBuilder();

            for (int i = 0; i < length; i++) {
                builder.append(random.nextInt());
            }

            return builder.toString();
        });

        generators.put(Map.class, aClass -> {
            int length = random.nextInt(10);
            Map<Object, Object> map = new HashMap<>();
            for (int i = 0; i < length; i++) {
                map.put(generators.get(Integer.class).apply(Integer.class), generators.get(String.class).apply(String.class));
            }

            return map;
        });
    }

    public static <T> T generateRandom(Class<T> clazz) {
        if (clazz.isEnum()) {
            return generateRandomEnum(clazz);
        } else {
            return (T) generators.get(clazz).apply(clazz);
        }
    }

    public static <T> T generateRandomEnum(Class<T> clazz) {
        return clazz.getEnumConstants()[random.nextInt(clazz.getEnumConstants().length)];
    }
}
